/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-06-26 16:27:34 UTC)
 * on 2013-07-31 at 17:30:38 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.sqladmin.model;

/**
 * An Operations resource contains information about database instance operations such as create,
 * delete, and restart. Operations resources are created in response to operations that were
 * initiated; you never create them directly.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Cloud SQL Administration API. For a detailed
 * explanation see:
 * <a href="http://code.google.com/p/google-http-java-client/wiki/JSON">http://code.google.com/p/google-http-java-client/wiki/JSON</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class InstanceOperation extends com.google.api.client.json.GenericJson {

  /**
   * The time this operation finished in UTC timezone in RFC 3339 format, for example
   * 2012-11-15T16:19:00.094Z.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private com.google.api.client.util.DateTime endTime;

  /**
   * The time this operation was enqueued in UTC timezone in RFC 3339 format, for example
   * 2012-11-15T16:19:00.094Z.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private com.google.api.client.util.DateTime enqueuedTime;

  /**
   * The error(s) encountered by this operation. Only set if the operation results in an error.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<OperationError> error;

  /**
   * The context for export operation, if applicable.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private ExportContext exportContext;

  /**
   * The context for import operation, if applicable.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private ImportContext importContext;

  /**
   * Name of the database instance.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String instance;

  /**
   * This is always sql#instanceOperation.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String kind;

  /**
   * An identifier that uniquely identifies the operation. You can use this identifier to retrieve
   * the Operations resource that has information about the operation.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String operation;

  /**
   * The type of the operation. Valid values are CREATE, DELETE, UPDATE, RESTART, IMPORT, EXPORT,
   * BACKUP_VOLUME, RESTORE_VOLUME.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String operationType;

  /**
   * The time this operation actually started in UTC timezone in RFC 3339 format, for example
   * 2012-11-15T16:19:00.094Z.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private com.google.api.client.util.DateTime startTime;

  /**
   * The state of an operation. Valid values are PENDING, RUNNING, DONE, UNKNOWN.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String state;

  /**
   * The email address of the user who initiated this operation.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String userEmailAddress;

  /**
   * The time this operation finished in UTC timezone in RFC 3339 format, for example
   * 2012-11-15T16:19:00.094Z.
   * @return value or {@code null} for none
   */
  public com.google.api.client.util.DateTime getEndTime() {
    return endTime;
  }

  /**
   * The time this operation finished in UTC timezone in RFC 3339 format, for example
   * 2012-11-15T16:19:00.094Z.
   * @param endTime endTime or {@code null} for none
   */
  public InstanceOperation setEndTime(com.google.api.client.util.DateTime endTime) {
    this.endTime = endTime;
    return this;
  }

  /**
   * The time this operation was enqueued in UTC timezone in RFC 3339 format, for example
   * 2012-11-15T16:19:00.094Z.
   * @return value or {@code null} for none
   */
  public com.google.api.client.util.DateTime getEnqueuedTime() {
    return enqueuedTime;
  }

  /**
   * The time this operation was enqueued in UTC timezone in RFC 3339 format, for example
   * 2012-11-15T16:19:00.094Z.
   * @param enqueuedTime enqueuedTime or {@code null} for none
   */
  public InstanceOperation setEnqueuedTime(com.google.api.client.util.DateTime enqueuedTime) {
    this.enqueuedTime = enqueuedTime;
    return this;
  }

  /**
   * The error(s) encountered by this operation. Only set if the operation results in an error.
   * @return value or {@code null} for none
   */
  public java.util.List<OperationError> getError() {
    return error;
  }

  /**
   * The error(s) encountered by this operation. Only set if the operation results in an error.
   * @param error error or {@code null} for none
   */
  public InstanceOperation setError(java.util.List<OperationError> error) {
    this.error = error;
    return this;
  }

  /**
   * The context for export operation, if applicable.
   * @return value or {@code null} for none
   */
  public ExportContext getExportContext() {
    return exportContext;
  }

  /**
   * The context for export operation, if applicable.
   * @param exportContext exportContext or {@code null} for none
   */
  public InstanceOperation setExportContext(ExportContext exportContext) {
    this.exportContext = exportContext;
    return this;
  }

  /**
   * The context for import operation, if applicable.
   * @return value or {@code null} for none
   */
  public ImportContext getImportContext() {
    return importContext;
  }

  /**
   * The context for import operation, if applicable.
   * @param importContext importContext or {@code null} for none
   */
  public InstanceOperation setImportContext(ImportContext importContext) {
    this.importContext = importContext;
    return this;
  }

  /**
   * Name of the database instance.
   * @return value or {@code null} for none
   */
  public java.lang.String getInstance() {
    return instance;
  }

  /**
   * Name of the database instance.
   * @param instance instance or {@code null} for none
   */
  public InstanceOperation setInstance(java.lang.String instance) {
    this.instance = instance;
    return this;
  }

  /**
   * This is always sql#instanceOperation.
   * @return value or {@code null} for none
   */
  public java.lang.String getKind() {
    return kind;
  }

  /**
   * This is always sql#instanceOperation.
   * @param kind kind or {@code null} for none
   */
  public InstanceOperation setKind(java.lang.String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * An identifier that uniquely identifies the operation. You can use this identifier to retrieve
   * the Operations resource that has information about the operation.
   * @return value or {@code null} for none
   */
  public java.lang.String getOperation() {
    return operation;
  }

  /**
   * An identifier that uniquely identifies the operation. You can use this identifier to retrieve
   * the Operations resource that has information about the operation.
   * @param operation operation or {@code null} for none
   */
  public InstanceOperation setOperation(java.lang.String operation) {
    this.operation = operation;
    return this;
  }

  /**
   * The type of the operation. Valid values are CREATE, DELETE, UPDATE, RESTART, IMPORT, EXPORT,
   * BACKUP_VOLUME, RESTORE_VOLUME.
   * @return value or {@code null} for none
   */
  public java.lang.String getOperationType() {
    return operationType;
  }

  /**
   * The type of the operation. Valid values are CREATE, DELETE, UPDATE, RESTART, IMPORT, EXPORT,
   * BACKUP_VOLUME, RESTORE_VOLUME.
   * @param operationType operationType or {@code null} for none
   */
  public InstanceOperation setOperationType(java.lang.String operationType) {
    this.operationType = operationType;
    return this;
  }

  /**
   * The time this operation actually started in UTC timezone in RFC 3339 format, for example
   * 2012-11-15T16:19:00.094Z.
   * @return value or {@code null} for none
   */
  public com.google.api.client.util.DateTime getStartTime() {
    return startTime;
  }

  /**
   * The time this operation actually started in UTC timezone in RFC 3339 format, for example
   * 2012-11-15T16:19:00.094Z.
   * @param startTime startTime or {@code null} for none
   */
  public InstanceOperation setStartTime(com.google.api.client.util.DateTime startTime) {
    this.startTime = startTime;
    return this;
  }

  /**
   * The state of an operation. Valid values are PENDING, RUNNING, DONE, UNKNOWN.
   * @return value or {@code null} for none
   */
  public java.lang.String getState() {
    return state;
  }

  /**
   * The state of an operation. Valid values are PENDING, RUNNING, DONE, UNKNOWN.
   * @param state state or {@code null} for none
   */
  public InstanceOperation setState(java.lang.String state) {
    this.state = state;
    return this;
  }

  /**
   * The email address of the user who initiated this operation.
   * @return value or {@code null} for none
   */
  public java.lang.String getUserEmailAddress() {
    return userEmailAddress;
  }

  /**
   * The email address of the user who initiated this operation.
   * @param userEmailAddress userEmailAddress or {@code null} for none
   */
  public InstanceOperation setUserEmailAddress(java.lang.String userEmailAddress) {
    this.userEmailAddress = userEmailAddress;
    return this;
  }

  @Override
  public InstanceOperation set(String fieldName, Object value) {
    return (InstanceOperation) super.set(fieldName, value);
  }

  @Override
  public InstanceOperation clone() {
    return (InstanceOperation) super.clone();
  }

}
